#include "rtai.h"
#include "rtai_sched.h"

extern void task1(long dummy);
extern void task2(long dummy);
extern void task3(long dummy);

static RT_TASK *id;

static RT_TASK *create_threads(void)
{
    static RT_TASK id[3];
    RTIME period_count;
    int err;

    period_count = nano2count(20000000);
    start_rt_timer(10000000);
    err = rt_task_init(&id[0], task1, 0, 1024,
                       RT_SCHED_LOWEST_PRIORITY, 0, 0);
    if (err) {
        printk("Error creating RT Task\n");
    }

    err = rt_task_make_periodic(&id[0], rt_get_time() + period_count, period_count);
    if (err) {
      printk("Error starting periodic task\n");
    }
    
    period_count = nano2count(50000000);
    err = rt_task_init(&id[1], task2, 0, 1024,
                       RT_SCHED_LOWEST_PRIORITY, 0, 0);
    if (err) {
        printk("Error creating RT Task\n");
    }

    err = rt_task_make_periodic(&id[1], rt_get_time() + period_count, period_count);
    if (err) {
      printk("Error starting periodic task\n");
    }
    
    period_count = nano2count(70000000);
    err = rt_task_init(&id[2], task3, 0, 1024,
                       RT_SCHED_LOWEST_PRIORITY, 0, 0);
    if (err) {
        printk("Error creating RT Task\n");
    }

    err = rt_task_make_periodic(&id[2], rt_get_time() + period_count, period_count);
    if (err) {
      printk("Error starting periodic task\n");
    }
    
    return id;
}

static void kill_threads(RT_TASK *id)
{
    int i;

    for (i = 0; i < 3; i++) {
        rt_task_delete(&id[i]);
    }
}

static int __init program_start(void)
{
  rt_set_periodic_mode();
  id = create_threads();

  return 0;
}

static void __exit program_end(void)
{
  kill_threads(id);
}

module_init(program_start);
module_exit(program_end);
